package geocode;

import java.util.List;

import log.SystemLogger;

import setting.GeocodeSettings;

/**
 * nf[^Ƃ肷NX
 * 
 * @author Toshiyuki Sato
 * 
 */
public class GeoDataManager {

	// ϐS
	GeocodeSettings settings;

	/**
	 * RXgN^
	 * 
	 * @param settings
	 */
	public GeoDataManager(GeocodeSettings settings) {
		this.settings = settings;
	}

	/**
	 * f[^x[XXV
	 * 
	 * @param searchKey
	 */
	public void updateDatabase(String searchKey, DBManager manager) {
		SystemLogger.writer.writeDebug("Try to update DB for " + searchKey);// fobOvg
		updateSearchKey(searchKey, manager);
		updateData(searchKey, manager);
		SystemLogger.writer
				.writeDebug("Finished to update DB for " + searchKey);// fobOvg
	}

	/**
	 * n擾
	 * 
	 * @param searchKey
	 * @return
	 */
	public List<GeoData> getGeoDatas(String searchKey, DBManager manager) {
		SystemLogger.writer.writeDebug("Try to get GeoDatas from DB for"
				+ searchKey);// fobOvg
		List<GeoData> geoData = manager.getGeodata(searchKey);
		SystemLogger.writer.writeDebug("got" + geoData.size()
				+ " GeoDatas from DB");// fobOvg
		return geoData;
	}

	/**
	 * L[XV
	 * 
	 * @param searchKey
	 */
	private void updateSearchKey(String searchKey, DBManager dbManager) {
		SystemLogger.writer.writeDebug("Try to update SearchKey Table for "
				+ searchKey);// fobOvg
		if (dbManager.keyExist(searchKey)) {// L[DBɑ݂Ăꍇ
			dbManager.updateRequestTimes(searchKey);// ANZX̉񐔂𑝂₷
			if (dbManager.keyExpired(searchKey)) {// L[̗LԂ߂Ăꍇ
				// DBXV
				APIManager apiManager = new APIManager(settings);
				List<String> searchList = apiManager.getSearchList(searchKey);
				dbManager.updateKey(searchKey, searchList);
			} else {
				SystemLogger.writer
						.writeDebug("No need to update SearchKey for "
								+ searchKey);// fobOvg
			}
		} else {// ݂ĂȂꍇ
			// VKɎ擾ADBɒǉ
			APIManager apiManager = new APIManager(settings);
			List<String> searchList = apiManager.getSearchList(searchKey);
			dbManager.addKey(searchKey, searchList);
		}
		SystemLogger.writer.writeDebug("Finished update SearchKey Table for "
				+ searchKey);// fobOvg
	}

	/**
	 * nXV
	 * 
	 * @param searchKey
	 */
	private void updateData(String searchKey, DBManager dbManager) {
		SystemLogger.writer.writeDebug("Try to update GeoData Table");// fobOvg
		List<String> locationNames = dbManager.getLocationNameList(searchKey);
		// nƂɒnXV
		if (locationNames != null && !locationNames.isEmpty()) {// n݂ꍇ
			for (String locationName : locationNames) {
				SystemLogger.writer.writeDebug("Target location name :"
						+ locationName);// fobOvg
				if (dbManager.dataExist(locationName)) {// nDBɑ݂Ăꍇ
					if (dbManager.dataExpired(locationName)) {// n̗LԂ߂Ăꍇ
						// DBXV
						APIManager apiManager = new APIManager(settings);
						GeoData geoData = apiManager.getLocation(locationName);
						if (geoData.isNotEmpty()) {
							dbManager.updateData(geoData);
						}
					} else {// ߂ĂȂꍇ
						SystemLogger.writer
								.writeDebug("No need to update location :"
										+ locationName);// fobOvg
					}
				} else {// ݂ĂȂꍇ
					// VKɎ擾ADBɒǉ
					APIManager apiManager = new APIManager(settings);
					GeoData geoData = apiManager.getLocation(locationName);
					dbManager.addData(geoData);
				}
			}
		} else {
			SystemLogger.writer.writeDebug("No target to update geodata");// fobOvg
		}
		SystemLogger.writer.writeDebug("Finished update GeoData Table");// fobOvg
	}

}
