package log;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Ȍo͂ǗNX
 * 
 * @author Hideyuki Hirasawa
 * @version 0.1
 */
public class LogWriter {

	public static final int ERROR = 0;

	public static final int WARNING = 1;

	public static final int INFO = 2;

	public static final int DEBUG = 3;

	private static int logLevel = DEBUG;

	private static String encode = "UTF-8";

	private String path = ".";

	private String filename = "default";

	private String extension = ".txt";

	/**
	 * RXgN^
	 * 
	 * @param filename
	 *            t@C
	 * @param extension
	 *            t@Cgq
	 */
	public LogWriter(String filename, String extension) {
		this.filename = filename;
		this.extension = extension;
	}

	/**
	 * o̓GR[hύX
	 * 
	 * @param newEncode
	 *            VGR[h
	 */
	public static void setEncode(String encode) {
		LogWriter.encode = encode;
	}

	/**
	 * Oxݒ肷
	 * 
	 * @param logLevel
	 *            VOx
	 */
	public static void setLogLevel(int logLevel) {
		LogWriter.logLevel = logLevel;
	}

	/**
	 * o̓pXݒ肷
	 * 
	 * @param newPath
	 */
	public void setPath(String newPath) {
		path = newPath;
	}

	/**
	 * DEBUGbZ[WOɏo͂
	 * 
	 * @param message
	 *            bZ[W
	 */
	public void writeDebug(String message) {
		if (logLevel >= DEBUG) {
			writeLog(getFilePath(), "DEBUG: " + message);
		}
	}

	/**
	 * INFObZ[WOɏo͂
	 * 
	 * @param message
	 *            bZ[W
	 */
	public void writeInfo(String message) {
		if (logLevel >= INFO) {
			writeLog(getFilePath(), "INFO: " + message);
		}
	}

	/**
	 * WARNINGbZ[WOɏo͂
	 * 
	 * @param message
	 *            bZ[W
	 */
	public void writeWarning(String message) {
		if (logLevel >= WARNING) {
			writeLog(getFilePath(), "WARNING: " + message);
		}
	}

	/**
	 * ERRORbZ[WOɏo
	 * 
	 * @param message
	 *            bZ[W
	 */
	public void writeError(String message) {
		if (logLevel >= ERROR) {
			writeLog(getFilePath(), "ERROR: " + message);
		}
	}

	/**
	 * ERRORbZ[WOɏo
	 * 
	 * @param message
	 *            bZ[W
	 * @param e
	 */
	public void writeError(String message, Exception e) {
		if (logLevel >= ERROR) {
			writeLog(getFilePath(), "ERROR: " + message, e);
		}
	}

	/**
	 * Oo͂
	 * 
	 * @param path
	 *            pX
	 * @param content
	 *            o͓e
	 */
	public void writeLog(String filePath, String content) {
		writeLog(filePath, content, null);
	}

	/**
	 * Oo͂
	 * 
	 * @param path
	 *            pX
	 * @param content
	 *            o͓e
	 */
	public void writeLog(String filePath, String content, Exception ec) {
		try {
			File log = new File(filePath);
			synchronized (log) {
				FileOutputStream fOut = new FileOutputStream(filePath, true);
				OutputStreamWriter oStream = new OutputStreamWriter(fOut,
						encode);
				BufferedWriter bWriter = new BufferedWriter(oStream);
				bWriter.write(getDateTime() + content);
				bWriter.newLine();
				if (ec != null && ec.getMessage() != null) {
					bWriter.write(ec.getMessage());
					bWriter.newLine();
				}
				bWriter.close();
			}
		} catch (IOException e) {
		}
	}

	/**
	 * ÕpXԂ
	 * 
	 * @return
	 */
	public String getFilePath() {
		return path + File.separator + filename + getDate() + extension;
	}

	/**
	 * t擾
	 * 
	 * @return o͗F "20070101" i2007N11j
	 */
	private String getDate() {
		SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd");
		return df.format(new Date());
	}

	/**
	 * tƎԂ擾
	 * 
	 * @return o͗F "2007/01/01 00:00:00" i2007N11 000bj
	 */
	private String getDateTime() {
		SimpleDateFormat df = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss ");
		return df.format(new Date());
	}

}