package test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import geocode.DBManager;
import geocode.GeoData;
import geocode.GeoDataManager;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Date;
import java.util.List;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import setting.GeocodeSettings;

public class TestGeoDataManager {

	private static GeoDataManager manager;

	private static DBManager dbManager;

	private static Statement stat;

	/**
	 * L[XVeXg
	 */
	@Test
	public void testUpdateDatabase() {
		// L[֘ÃeXg
		{
			// L[ɑΉ錟ĂȂꍇAL[ǉĂ
			manager.updateDatabase("l", dbManager);
			String result = getValueFromDB("GeocodingRequest", "searchQuery",
					"searchQuery", "l");
			assertEquals("l", result);
			// L[ɑΉ錟ĂAXVԂ߂ĂꍇAL[XV
			Date date = getDateFromDB("GeocodingRequest", "lastUpdatedRequest",
					"searchQuery", "]");
			manager.updateDatabase("]", dbManager);
			Date newDate = getDateFromDB("GeocodingRequest",
					"lastUpdatedRequest", "searchQuery", "]");
			assertTrue(date.before(newDate));
			// L[ɑΉ錟ĂAXVԂ߂ĂȂꍇAL[񐔈ȊOXVȂ
			date = getDateFromDB("GeocodingRequest", "lastUpdatedRequest",
					"searchQuery", "");
			manager.updateDatabase("", dbManager);
			newDate = getDateFromDB("GeocodingRequest", "lastUpdatedRequest",
					"searchQuery", "");
			assertEquals(date, newDate);
		}

		setTestDatas();// xZbg

		// n֘ÃeXg
		{
			// L[ɑΉn񂪑݂ȂꍇAn񂪒ǉĂ
			manager.updateDatabase("l", dbManager);
			String result = getValueFromDB("GeocodingData", "locationName",
					"locationName", "l");
			assertEquals("l", result);
			// L[ɑΉn񂪑݂AXVԂ߂ĂꍇAn񂪍XVĂ
			Date date = getDateFromDB("GeocodingData", "lastUpdated",
					"locationName", "]");
			manager.updateDatabase("]", dbManager);
			Date newDate = getDateFromDB("GeocodingData", "lastUpdated",
					"locationName", "]");
			assertTrue(date.before(newDate));
			// L[ɑΉn񂪑݂AXVԂ߂ĂȂꍇAύXȂ
			date = getDateFromDB("GeocodingData", "lastUpdated",
					"locationName", "");
			manager.updateDatabase("", dbManager);
			newDate = getDateFromDB("GeocodingData", "lastUpdated",
					"locationName", "");
			assertEquals(date, newDate);
		}
	}

	/**
	 * n擾eXg
	 */
	@Test
	public void TestGetGeoDatas() {
		List<GeoData> geoDatas;
		// n1擾łꍇA1XgɓԂŎ擾ł
		geoDatas = manager.getGeoDatas("", dbManager);
		assertEquals(1, geoDatas.size());
		assertEquals("", geoDatas.get(0).getLocationName());
		// n񂪕擾łꍇAXgɓԂŎ擾ł
		geoDatas = manager.getGeoDatas("Oc", dbManager);
		assertEquals(2, geoDatas.size());
		assertEquals("Ocwij", geoDatas.get(0).getLocationName());
		assertEquals("OcwiɁj", geoDatas.get(1).getLocationName());
		// n񂪎擾łȂꍇÃXg擾ł
		geoDatas = manager.getGeoDatas("", dbManager);
		assertEquals(0, geoDatas.size());
	}

	/***************************************************************************
	 * 
	 * eXgpӗp\bhS
	 * 
	 **************************************************************************/

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		// CX^X𐶐
		GeocodeSettings settings = new GeocodeSettings();
		settings.readConfigFile();
		dbManager = new DBManager(settings);
		// DB̐ݒiłj
		manager = new GeoDataManager(settings);
		Class.forName("org.gjt.mm.mysql.Driver");
		Connection c = DriverManager
				.getConnection(
						"jdbc:mysql:///GeocodingModuleDB?useUnicode=true&characterEncoding=UTF8",
						"root", "");
		stat = c.createStatement();
	}

	@Before
	public void setUp() throws Exception {
		setTestDatas();
	}

	/**
	 * DB
	 */
	private void setTestDatas() {
		try {
			String searchQuery;
			String locationName;

			// DB
			String sql = "delete from geocodingRequest";
			stat.executeUpdate(sql);
			sql = "delete from geocodingLink";
			stat.executeUpdate(sql);
			sql = "delete from geocodingData";
			stat.executeUpdate(sql);

			// f[^pӂ
			// L[֘A
			{
				// ؂ĂȂꍇ
				{
					// PƂ̏ꍇ
					searchQuery = "";
					locationName = "";
					java.sql.Date date = new java.sql.Date(new Date().getTime()
							- 1000L * 24L * 60L * 60L);
					sql = "insert into geocodingRequest values ('"
							+ searchQuery + "',1,'" + date + "')";
					stat.executeUpdate(sql);
					sql = "insert into geocodingLink values ('" + searchQuery
							+ "','" + locationName + "',1)";
					stat.executeUpdate(sql);
					// ݂ꍇ
					searchQuery = "Oc";
					locationName = "Ocwij";
					date = new java.sql.Date(new Date().getTime());
					sql = "insert into geocodingRequest values ('"
							+ searchQuery + "',2,'" + date + "')";
					stat.executeUpdate(sql);
					sql = "insert into geocodingLink values ('" + searchQuery
							+ "','" + locationName + "',1)";
					stat.executeUpdate(sql);
					locationName = "OcwiɁj";
					sql = "insert into geocodingLink values ('" + searchQuery
							+ "','" + locationName + "',2)";
					stat.executeUpdate(sql);
				}
				// ؂Ăꍇ
				searchQuery = "]";
				locationName = "]";
				Date date = new java.sql.Date(0);
				sql = "insert into geocodingRequest values ('" + searchQuery
						+ "',1,'" + date + "')";
				stat.executeUpdate(sql);
				sql = "insert into geocodingLink values ('" + searchQuery
						+ "','" + locationName + "',1)";
				stat.executeUpdate(sql);

			}
			// n֘A
			{
				// ؂ĂȂꍇ
				{
					java.sql.Date date = new java.sql.Date(new Date().getTime());
					// PƂ̏ꍇ
					locationName = "";
					sql = "insert into geocodingData values ('" + locationName
							+ "',100,200,'" + date + "','" + date + "')";
					stat.executeUpdate(sql);
					// ̏ꍇ
					locationName = "Ocwij";
					sql = "insert into geocodingData values ('" + locationName
							+ "',200,300,'" + date + "','" + date + "')";
					stat.executeUpdate(sql);
					locationName = "OcwiɁj";
					sql = "insert into geocodingData values ('" + locationName
							+ "',200,300,'" + date + "','" + date + "')";
					stat.executeUpdate(sql);
				}
				// ؂Ăꍇ
				Date date = new java.sql.Date(0);
				locationName = "]";
				sql = "insert into geocodingData values ('" + locationName
						+ "',100,200,'" + date + "','" + date + "')";
				stat.executeUpdate(sql);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * DB擾lQbg
	 */
	private String getValueFromDB(String table, String target, String rowName,
			String request) {
		try {
			// 擾
			String sql = "select " + target + " from " + table + " where "
					+ rowName + " ='" + request + "'";
			ResultSet rs = stat.executeQuery(sql);

			// 擾łׂ
			while (rs.next()) {
				return rs.getString(target);
			}
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * DB擾tQbg
	 */
	private Date getDateFromDB(String table, String target, String rowName,
			String request) {
		try {
			// 擾
			String sql = "select " + target + " from " + table + " where "
					+ rowName + " ='" + request + "'";
			ResultSet rs = stat.executeQuery(sql);

			// 擾łׂ
			while (rs.next()) {
				return rs.getDate(target);
			}
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}
}