package test;

import static org.junit.Assert.assertTrue;

import java.io.File;

import log.LogWriter;
import log.SystemLogger;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class TestLogWriter {

	private String fileName;

	@Before
	public void setUp() throws Exception {
		fileName = SystemLogger.writer.getFilePath();
		SystemLogger.writer.setPath(".");
		LogWriter.setLogLevel(LogWriter.DEBUG);
	}

	@After
	public void tearDown() throws Exception {
		(new File(fileName)).delete();
	}

	/**
	 * ȌóEo͂eXg
	 */
	@Test
	public final void testEnable() {
		// O̔o͂eXg
		LogWriter.setLogLevel(LogWriter.INFO);
		SystemLogger.writer.writeDebug("Test1");
		assertTrue(!(new File(fileName)).exists());

		// Ȍo͂eXg
		SystemLogger.writer.writeError("Test2");
		assertTrue((new File(fileName)).exists());
	}

	/**
	 * Ȍo͋@\eXg
	 */
	@Test
	public final void testWrite() {
		SystemLogger.writer.writeError("Test3", null);
		assertTrue((new File(fileName)).exists());
	}
	
	/**
	 * Ȍo̓pXݒeXg
	 */
	@Test
	public final void testSetPath() {
		(new File("test_dir")).mkdir();
		SystemLogger.writer.setPath("test_dir");
		SystemLogger.writer.writeError("Test4", null);
		assertTrue((new File("test_dir" + File.separator + fileName)).exists());
		(new File("test_dir" + File.separator + fileName)).delete();
		(new File("test_dir")).delete();
	}


}
